package org.vraptor.core;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.vraptor.LogicException;
import org.vraptor.component.ComponentNotFoundException;
import org.vraptor.component.LogicNotFoundException;
import org.vraptor.interceptor.InterceptorInstantiationException;
import org.vraptor.introspector.BasicIntrospector;
import org.vraptor.introspector.Introspector;
import org.vraptor.url.InvalidURLException;
import org.vraptor.url.RequestInfo;
import org.vraptor.view.ViewException;
import org.vraptor.webapp.WebApplication;

/**
 * Main vraptor2 controller.
 * 
 * @author Guilherme Silveira
 */
public class VRaptorController {

	private static final Logger LOG = Logger.getLogger(VRaptorController.class);

	private Introspector introspector = new BasicIntrospector();

	private WebApplication application;

	/**
	 * @param application
	 */
	public VRaptorController(WebApplication application) {
		this.application = application;
	}

	/**
	 * Returns the instrospector
	 * 
	 * @return
	 */
	public Introspector getIntrospector() {
		return this.introspector;
	}

	/**
	 * @return the application
	 */
	public WebApplication getWebApplication() {
		return application;
	}

	public void execute(WebRequest request) throws InvalidURLException, ComponentNotFoundException,
			LogicNotFoundException, ViewException, InterceptorInstantiationException, LogicException {

		RequestInfo requestInfo = getWebApplication().getURLManager().extractInfoFromURL(request.getRequest());

		new VRaptorExecution(requestInfo, this, request).execute();
	}

}
